<template>
  <div class="notification d-flex flex-row bg-white m-1 mb-0 max-w-100">
    <slot>
      <span class="text-left ph-4 pv-2">
        {{ data.text }}
      </span>
    </slot>
    <button class="icon-button flex-as-center ph-3 ml-auto" @click="dismiss">
      <v-icon name="times"/>
    </button>
  </div>
</template>

<script>
import Vue from 'vue';

export default {
  props: {
    data: {
      type: Object,
      required: true,
    },
  },
  methods: {
    dismiss() {
      if (this.$props.data.read)
        return;

      let i = this.$store.state.notifications
        .findIndex((v) => v._id === this.$props.data._id);

      if (i === -1)
        return;

      Vue.set(this.$store.state.notifications[i], 'read', true);
    },
  },
  mounted() {
    // auto-dismiss in 8s
    setTimeout(this.dismiss, 8000);
  },
};
</script>

<style scoped>

.notification {
  overflow: hidden;
  box-shadow: 0 2px 4px rgba(0, 0, 0, .08);
  border-radius: 8px;
}

span {
  font-size: 10pt;
  word-wrap: break-word;
  flex-shrink: 1;
  min-width: 0;
  text-overflow: ellipsis;
}

button {
  flex-shrink: 0;
  align-self: stretch;
}

</style>
